<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (1.8.0_131) on Mon Jul 17 12:51:54 CEST 2017 -->
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>Board (APP)</title>
<meta name="date" content="2017-07-17">
<link rel="stylesheet" type="text/css" href="../../stylesheet.css" title="Style">
<script type="text/javascript" src="../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="Board (APP)";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":10,"i1":10,"i2":10,"i3":10,"i4":10,"i5":10,"i6":10,"i7":10,"i8":10,"i9":10,"i10":10};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/Board.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../index-all.html">Index</a></li>
<li><a href="../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li>Prev&nbsp;Class</li>
<li><a href="../../towerwarspp/board/BViewer.html" title="class in towerwarspp.board"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../index.html?towerwarspp/board/Board.html" target="_top">Frames</a></li>
<li><a href="Board.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">towerwarspp.board</div>
<h2 title="Class Board" class="title">Class Board</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li>java.lang.Object</li>
<li>
<ul class="inheritance">
<li><a href="../../towerwarspp/board/SimpleBoard.html" title="class in towerwarspp.board">towerwarspp.board.SimpleBoard</a></li>
<li>
<ul class="inheritance">
<li>towerwarspp.board.Board</li>
</ul>
</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<dl>
<dt>All Implemented Interfaces:</dt>
<dd><a href="../../towerwarspp/preset/Viewable.html" title="interface in towerwarspp.preset">Viewable</a></dd>
</dl>
<hr>
<br>
<pre>public class <span class="typeNameLabel">Board</span>
extends <a href="../../towerwarspp/board/SimpleBoard.html" title="class in towerwarspp.board">SimpleBoard</a></pre>
<div class="block">This class represents an extended board which, on the one hand, has the same functionality as <a href="../../towerwarspp/board/SimpleBoard.html" title="class in towerwarspp.board"><code>SimpleBoard</code></a>
 and on the other hand, gives the possibility to score moves according to different score strategies, including the simple one.
 On request, the <a href="../../towerwarspp/board/Board.html" title="class in towerwarspp.board"><code>Board</code></a> provides a list of all possible moves which the player of the specified color has.
 It also determines and delivers the best possible moves for the specified player evaluated according to the simple score strategy.</div>
<dl>
<dt><span class="simpleTagLabel">Version:</span></dt>
<dd>15-07-17</dd>
<dt><span class="simpleTagLabel">Author:</span></dt>
<dd>Alexander Wähling</dd>
</dl>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- =========== FIELD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="field.summary">
<!--   -->
</a>
<h3>Field Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Field Summary table, listing fields, and an explanation">
<caption><span>Fields</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Field and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private static int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/Board.html#DEFENCE">DEFENCE</a></span></code>
<div class="block">Constant used in the evaluation of moves in <a href="../../towerwarspp/board/Board.html#altScore-towerwarspp.preset.Move-towerwarspp.preset.PlayerColor-"><code>altScore(Move, PlayerColor)</code></a>.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private static int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/Board.html#DEFEND">DEFEND</a></span></code>
<div class="block">Constant used in the evaluation of moves in <a href="../../towerwarspp/board/Board.html#altScore-towerwarspp.preset.Move-towerwarspp.preset.PlayerColor-"><code>altScore(Move, PlayerColor)</code></a>.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>static int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/Board.html#LOSE">LOSE</a></span></code>
<div class="block">Constant used in the evaluation of moves in <a href="../../towerwarspp/board/Board.html#altScore-towerwarspp.preset.Move-towerwarspp.preset.PlayerColor-"><code>altScore(Move, PlayerColor)</code></a>.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>static int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/Board.html#WIN">WIN</a></span></code>
<div class="block">Constant used in the evaluation of moves in <a href="../../towerwarspp/board/Board.html#altScore-towerwarspp.preset.Move-towerwarspp.preset.PlayerColor-"><code>altScore(Move, PlayerColor)</code></a>.</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="fields.inherited.from.class.towerwarspp.board.SimpleBoard">
<!--   -->
</a>
<h3>Fields inherited from class&nbsp;towerwarspp.board.<a href="../../towerwarspp/board/SimpleBoard.html" title="class in towerwarspp.board">SimpleBoard</a></h3>
<code><a href="../../towerwarspp/board/SimpleBoard.html#blueBase">blueBase</a>, <a href="../../towerwarspp/board/SimpleBoard.html#debug">debug</a>, <a href="../../towerwarspp/board/SimpleBoard.html#listBlue">listBlue</a>, <a href="../../towerwarspp/board/SimpleBoard.html#listRed">listRed</a>, <a href="../../towerwarspp/board/SimpleBoard.html#redBase">redBase</a>, <a href="../../towerwarspp/board/SimpleBoard.html#size">size</a>, <a href="../../towerwarspp/board/SimpleBoard.html#turn">turn</a></code></li>
</ul>
</li>
</ul>
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Constructor Summary table, listing constructors, and an explanation">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colOne" scope="col">Constructor and Description</th>
</tr>
<tr class="altColor">
<td class="colOne"><code><span class="memberNameLink"><a href="../../towerwarspp/board/Board.html#Board-int-">Board</a></span>(int&nbsp;n)</code>
<div class="block">Initialises a new object of the class Board.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colOne"><code><span class="memberNameLink"><a href="../../towerwarspp/board/Board.html#Board-int-towerwarspp.preset.PlayerColor-java.util.Vector-java.util.Vector-towerwarspp.board.Entity:A:A-towerwarspp.preset.Position-towerwarspp.preset.Position-">Board</a></span>(int&nbsp;size,
     <a href="../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a>&nbsp;turn,
     java.util.Vector&lt;<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&gt;&nbsp;lRed,
     java.util.Vector&lt;<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&gt;&nbsp;lBlue,
     <a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>[][]&nbsp;board,
     <a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;redB,
     <a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;blueB)</code>
<div class="block">Initialises a new object of the class Board with the specified parameters.</div>
</td>
</tr>
</table>
</li>
</ul>
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code>java.util.Vector&lt;<a href="../../towerwarspp/preset/Move.html" title="class in towerwarspp.preset">Move</a>&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/Board.html#allPossibleMoves-towerwarspp.preset.PlayerColor-">allPossibleMoves</a></span>(<a href="../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a>&nbsp;col)</code>
<div class="block">Returns all possible moves which a player of the color col has.</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code>int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/Board.html#altScore-towerwarspp.preset.Move-towerwarspp.preset.PlayerColor-">altScore</a></span>(<a href="../../towerwarspp/preset/Move.html" title="class in towerwarspp.preset">Move</a>&nbsp;move,
        <a href="../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a>&nbsp;playerColor)</code>
<div class="block">Computes an alternative score for the passed move representing an aggressive play strategy with some focus on
 defending the base by assigning a very low score to moves that cause an entity to leave an area around the base
 dependant on the board size.</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code>private boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/Board.html#canBeDestroyed-towerwarspp.preset.Position-java.util.Vector-">canBeDestroyed</a></span>(<a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;pos,
              java.util.Vector&lt;<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&gt;&nbsp;entities)</code>
<div class="block">Proves if a token located at the specified position can be destroyed (or blocked) by the opponent's stone.</div>
</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code><a href="../../towerwarspp/board/Board.html" title="class in towerwarspp.board">Board</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/Board.html#clone--">clone</a></span>()</code>
<div class="block">Clones the current <a href="../../towerwarspp/board/Board.html" title="class in towerwarspp.board"><code>Board</code></a> object and returns the clone.</div>
</td>
</tr>
<tr id="i4" class="altColor">
<td class="colFirst"><code>private java.util.Vector&lt;<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/Board.html#cloneAndPutOnBoard-java.util.Vector-towerwarspp.board.Entity:A:A-">cloneAndPutOnBoard</a></span>(java.util.Vector&lt;<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&gt;&nbsp;list,
                  <a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>[][]&nbsp;cloneBoard)</code>
<div class="block">Clones all entities in the given entity list and saves the clones on the correct positions
 in the specified array representation of the board.</div>
</td>
</tr>
<tr id="i5" class="rowColor">
<td class="colFirst"><code>private int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/Board.html#computeScore-towerwarspp.preset.Move-towerwarspp.preset.Position-towerwarspp.preset.PlayerColor-">computeScore</a></span>(<a href="../../towerwarspp/preset/Move.html" title="class in towerwarspp.preset">Move</a>&nbsp;move,
            <a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;opponentBase,
            <a href="../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a>&nbsp;ownColor)</code>
<div class="block">Computes a score for the given move using the simple strategy.</div>
</td>
</tr>
<tr id="i6" class="altColor">
<td class="colFirst"><code>java.util.Vector&lt;<a href="../../towerwarspp/preset/Move.html" title="class in towerwarspp.preset">Move</a>&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/Board.html#getBestMoves-towerwarspp.preset.PlayerColor-">getBestMoves</a></span>(<a href="../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a>&nbsp;ownColor)</code>
<div class="block">Returns the best moves available for the player of the color ownColor which have been rated
 according to the simple score strategy and with respect to each available move's possible consequence.</div>
</td>
</tr>
<tr id="i7" class="rowColor">
<td class="colFirst"><code>private boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/Board.html#haveManyMoves-java.util.Vector-">haveManyMoves</a></span>(java.util.Vector&lt;<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&gt;&nbsp;ownEntities)</code>
<div class="block">This function helps to prove if a player has enough tokens and possible moves so that the opponent cannot leave him/her
 without any moves by only one move.</div>
</td>
</tr>
<tr id="i8" class="altColor">
<td class="colFirst"><code>private boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/Board.html#playerCanWin-towerwarspp.board.Board-towerwarspp.preset.PlayerColor-">playerCanWin</a></span>(<a href="../../towerwarspp/board/Board.html" title="class in towerwarspp.board">Board</a>&nbsp;board,
            <a href="../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a>&nbsp;col)</code>
<div class="block">Returns true if at least one of the moves available for the player of the color col
 leads to the win.</div>
</td>
</tr>
<tr id="i9" class="rowColor">
<td class="colFirst"><code><a href="../../towerwarspp/board/MoveScore.html" title="class in towerwarspp.board">MoveScore</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/Board.html#scoreMove-towerwarspp.preset.Move-towerwarspp.preset.PlayerColor-">scoreMove</a></span>(<a href="../../towerwarspp/preset/Move.html" title="class in towerwarspp.preset">Move</a>&nbsp;move,
         <a href="../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a>&nbsp;ownColor)</code>
<div class="block">Returns a <a href="../../towerwarspp/board/MoveScore.html" title="class in towerwarspp.board"><code>MoveScore</code></a> object representing the information on the specified move: its score made according to the simple strategy
 and its possible consequence like immediate win or lose, or unknown result.</div>
</td>
</tr>
<tr id="i10" class="altColor">
<td class="colFirst"><code>private <a href="../../towerwarspp/board/MoveScore.html" title="class in towerwarspp.board">MoveScore</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/Board.html#scoreMove-towerwarspp.preset.Move-towerwarspp.preset.PlayerColor-boolean-">scoreMove</a></span>(<a href="../../towerwarspp/preset/Move.html" title="class in towerwarspp.preset">Move</a>&nbsp;move,
         <a href="../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a>&nbsp;ownColor,
         boolean&nbsp;ownBaseCanBeDestroyed)</code>
<div class="block">Evaluates the specified move.</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="methods.inherited.from.class.towerwarspp.board.SimpleBoard">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;towerwarspp.board.<a href="../../towerwarspp/board/SimpleBoard.html" title="class in towerwarspp.board">SimpleBoard</a></h3>
<code><a href="../../towerwarspp/board/SimpleBoard.html#distance-towerwarspp.preset.Position-towerwarspp.preset.Position-">distance</a>, <a href="../../towerwarspp/board/SimpleBoard.html#getElement-towerwarspp.preset.Position-">getElement</a>, <a href="../../towerwarspp/board/SimpleBoard.html#getEntityList-towerwarspp.preset.PlayerColor-">getEntityList</a>, <a href="../../towerwarspp/board/SimpleBoard.html#getSize--">getSize</a>, <a href="../../towerwarspp/board/SimpleBoard.html#getStatus--">getStatus</a>, <a href="../../towerwarspp/board/SimpleBoard.html#getTurn--">getTurn</a>, <a href="../../towerwarspp/board/SimpleBoard.html#getWinType--">getWinType</a>, <a href="../../towerwarspp/board/SimpleBoard.html#makeMove-towerwarspp.preset.Move-">makeMove</a>, <a href="../../towerwarspp/board/SimpleBoard.html#moveAllowed-towerwarspp.preset.Move-towerwarspp.preset.PlayerColor-">moveAllowed</a>, <a href="../../towerwarspp/board/SimpleBoard.html#viewer--">viewer</a></code></li>
</ul>
<ul class="blockList">
<li class="blockList"><a name="methods.inherited.from.class.java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.Object</h3>
<code>equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait</code></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ FIELD DETAIL =========== -->
<ul class="blockList">
<li class="blockList"><a name="field.detail">
<!--   -->
</a>
<h3>Field Detail</h3>
<a name="WIN">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>WIN</h4>
<pre>public static final&nbsp;int WIN</pre>
<div class="block">Constant used in the evaluation of moves in <a href="../../towerwarspp/board/Board.html#altScore-towerwarspp.preset.Move-towerwarspp.preset.PlayerColor-"><code>altScore(Move, PlayerColor)</code></a>. Represents a move that leads to
 direct victory.</div>
<dl>
<dt><span class="seeLabel">See Also:</span></dt>
<dd><a href="../../constant-values.html#towerwarspp.board.Board.WIN">Constant Field Values</a></dd>
</dl>
</li>
</ul>
<a name="LOSE">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>LOSE</h4>
<pre>public static final&nbsp;int LOSE</pre>
<div class="block">Constant used in the evaluation of moves in <a href="../../towerwarspp/board/Board.html#altScore-towerwarspp.preset.Move-towerwarspp.preset.PlayerColor-"><code>altScore(Move, PlayerColor)</code></a>. Represents a move that leads to
 to a position allowing the enmy to win within one move.</div>
<dl>
<dt><span class="seeLabel">See Also:</span></dt>
<dd><a href="../../constant-values.html#towerwarspp.board.Board.LOSE">Constant Field Values</a></dd>
</dl>
</li>
</ul>
<a name="DEFENCE">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>DEFENCE</h4>
<pre>private static final&nbsp;int DEFENCE</pre>
<div class="block">Constant used in the evaluation of moves in <a href="../../towerwarspp/board/Board.html#altScore-towerwarspp.preset.Move-towerwarspp.preset.PlayerColor-"><code>altScore(Move, PlayerColor)</code></a>. Is assigned to moves that have
 their starting position within a certain distance of their base. Is used so there are always a certain amount of
 entities guarding the base.</div>
<dl>
<dt><span class="seeLabel">See Also:</span></dt>
<dd><a href="../../constant-values.html#towerwarspp.board.Board.DEFENCE">Constant Field Values</a></dd>
</dl>
</li>
</ul>
<a name="DEFEND">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>DEFEND</h4>
<pre>private static final&nbsp;int DEFEND</pre>
<div class="block">Constant used in the evaluation of moves in <a href="../../towerwarspp/board/Board.html#altScore-towerwarspp.preset.Move-towerwarspp.preset.PlayerColor-"><code>altScore(Move, PlayerColor)</code></a>. Represents a move from an entity
 that was in a <a href="../../towerwarspp/board/Board.html#DEFENCE"><code>DEFENCE</code></a> position but now has the opportunity to defeat an enemy stone.</div>
<dl>
<dt><span class="seeLabel">See Also:</span></dt>
<dd><a href="../../constant-values.html#towerwarspp.board.Board.DEFEND">Constant Field Values</a></dd>
</dl>
</li>
</ul>
</li>
</ul>
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a name="Board-int-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>Board</h4>
<pre>public&nbsp;Board(int&nbsp;n)</pre>
<div class="block">Initialises a new object of the class Board.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>n</code> - - size of the new board.</dd>
</dl>
</li>
</ul>
<a name="Board-int-towerwarspp.preset.PlayerColor-java.util.Vector-java.util.Vector-towerwarspp.board.Entity:A:A-towerwarspp.preset.Position-towerwarspp.preset.Position-">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>Board</h4>
<pre>public&nbsp;Board(int&nbsp;size,
             <a href="../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a>&nbsp;turn,
             java.util.Vector&lt;<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&gt;&nbsp;lRed,
             java.util.Vector&lt;<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&gt;&nbsp;lBlue,
             <a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>[][]&nbsp;board,
             <a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;redB,
             <a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;blueB)</pre>
<div class="block">Initialises a new object of the class Board with the specified parameters.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>size</code> - size of the new board.</dd>
<dd><code>turn</code> - current turn.</dd>
<dd><code>lRed</code> - list of all red entities except the red base.</dd>
<dd><code>lBlue</code> - list of all blue entities except the blue base.</dd>
<dd><code>board</code> - representation of the board as a 2-dimensional array of entities.</dd>
<dd><code>redB</code> - position of the red base.</dd>
<dd><code>blueB</code> - position of the blue base.</dd>
</dl>
</li>
</ul>
</li>
</ul>
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="allPossibleMoves-towerwarspp.preset.PlayerColor-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>allPossibleMoves</h4>
<pre>public&nbsp;java.util.Vector&lt;<a href="../../towerwarspp/preset/Move.html" title="class in towerwarspp.preset">Move</a>&gt;&nbsp;allPossibleMoves(<a href="../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a>&nbsp;col)</pre>
<div class="block">Returns all possible moves which a player of the color col has.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>col</code> - the color of the player whose possible moves have to be returned.</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>all possible moves which a player of the color col has.</dd>
</dl>
</li>
</ul>
<a name="altScore-towerwarspp.preset.Move-towerwarspp.preset.PlayerColor-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>altScore</h4>
<pre>public&nbsp;int&nbsp;altScore(<a href="../../towerwarspp/preset/Move.html" title="class in towerwarspp.preset">Move</a>&nbsp;move,
                    <a href="../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a>&nbsp;playerColor)</pre>
<div class="block">Computes an alternative score for the passed move representing an aggressive play strategy with some focus on
 defending the base by assigning a very low score to moves that cause an entity to leave an area around the base
 dependant on the board size.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>move</code> - move to evaluate</dd>
<dd><code>playerColor</code> - player making that move</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>score for this move</dd>
</dl>
</li>
</ul>
<a name="scoreMove-towerwarspp.preset.Move-towerwarspp.preset.PlayerColor-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>scoreMove</h4>
<pre>public&nbsp;<a href="../../towerwarspp/board/MoveScore.html" title="class in towerwarspp.board">MoveScore</a>&nbsp;scoreMove(<a href="../../towerwarspp/preset/Move.html" title="class in towerwarspp.preset">Move</a>&nbsp;move,
                           <a href="../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a>&nbsp;ownColor)</pre>
<div class="block">Returns a <a href="../../towerwarspp/board/MoveScore.html" title="class in towerwarspp.board"><code>MoveScore</code></a> object representing the information on the specified move: its score made according to the simple strategy
 and its possible consequence like immediate win or lose, or unknown result.</div>
</li>
</ul>
<a name="getBestMoves-towerwarspp.preset.PlayerColor-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getBestMoves</h4>
<pre>public&nbsp;java.util.Vector&lt;<a href="../../towerwarspp/preset/Move.html" title="class in towerwarspp.preset">Move</a>&gt;&nbsp;getBestMoves(<a href="../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a>&nbsp;ownColor)</pre>
<div class="block">Returns the best moves available for the player of the color ownColor which have been rated
 according to the simple score strategy and with respect to each available move's possible consequence.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>ownColor</code> - the color of the player whose best possible moves have to be returned.</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the best possible moves which a player of the color ownColor has.</dd>
</dl>
</li>
</ul>
<a name="scoreMove-towerwarspp.preset.Move-towerwarspp.preset.PlayerColor-boolean-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>scoreMove</h4>
<pre>private&nbsp;<a href="../../towerwarspp/board/MoveScore.html" title="class in towerwarspp.board">MoveScore</a>&nbsp;scoreMove(<a href="../../towerwarspp/preset/Move.html" title="class in towerwarspp.preset">Move</a>&nbsp;move,
                            <a href="../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a>&nbsp;ownColor,
                            boolean&nbsp;ownBaseCanBeDestroyed)</pre>
<div class="block">Evaluates the specified move.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>move</code> - the move which has to be evaluated.</dd>
<dd><code>ownColor</code> - the color of the player whose turn it is to make a move and whose move has to be evaluated.</dd>
<dd><code>ownBaseCanBeDestroyed</code> - indicates if the opponent has a move which can destroy the current player's base.
                              If the value is true, it will be proved if the opponent still can destroy the base after the move in question.
                              If the value is false, no further examination concerning the current player's base is needed.</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>evaluation result as a MoveScore object containing the score and information on the possible consequence of the move.</dd>
</dl>
</li>
</ul>
<a name="computeScore-towerwarspp.preset.Move-towerwarspp.preset.Position-towerwarspp.preset.PlayerColor-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>computeScore</h4>
<pre>private&nbsp;int&nbsp;computeScore(<a href="../../towerwarspp/preset/Move.html" title="class in towerwarspp.preset">Move</a>&nbsp;move,
                         <a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;opponentBase,
                         <a href="../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a>&nbsp;ownColor)</pre>
<div class="block">Computes a score for the given move using the simple strategy.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>move</code> - the move in question.</dd>
<dd><code>opponentBase</code> - the position of the opponent's base.</dd>
<dd><code>ownColor</code> - the color of the player who can make the specified move.</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the score of the move made according to the simple score strategy.</dd>
</dl>
</li>
</ul>
<a name="haveManyMoves-java.util.Vector-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>haveManyMoves</h4>
<pre>private&nbsp;boolean&nbsp;haveManyMoves(java.util.Vector&lt;<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&gt;&nbsp;ownEntities)</pre>
<div class="block">This function helps to prove if a player has enough tokens and possible moves so that the opponent cannot leave him/her
 without any moves by only one move. It returns true if at least two tokens in the list ownEntities have 2 or more moves
 or there is at least one stone and one other token with 2 or more possible moves in this list.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>ownEntities</code> - the list of the tokens belonging to the player whose lose resistance has to be proved.</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>true if the player in question has enough moves and tokens not to lose as a result of the opponnt's move
 because of the absence of possible moves.</dd>
</dl>
</li>
</ul>
<a name="playerCanWin-towerwarspp.board.Board-towerwarspp.preset.PlayerColor-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>playerCanWin</h4>
<pre>private&nbsp;boolean&nbsp;playerCanWin(<a href="../../towerwarspp/board/Board.html" title="class in towerwarspp.board">Board</a>&nbsp;board,
                             <a href="../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a>&nbsp;col)</pre>
<div class="block">Returns true if at least one of the moves available for the player of the color col
 leads to the win.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>board</code> - the board with the current game situation.</dd>
<dd><code>col</code> - the color of the player in question. It is this player's turn to make a move.</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>true at least one of the moves available for the player of the color col
 leads to the win.</dd>
</dl>
</li>
</ul>
<a name="canBeDestroyed-towerwarspp.preset.Position-java.util.Vector-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>canBeDestroyed</h4>
<pre>private&nbsp;boolean&nbsp;canBeDestroyed(<a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;pos,
                               java.util.Vector&lt;<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&gt;&nbsp;entities)</pre>
<div class="block">Proves if a token located at the specified position can be destroyed (or blocked) by the opponent's stone.
 Returns true if this is possible which means if at least one opponent's token has a possible move to the specified position.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>pos</code> - the position of the token for which it has to be proved if it can be destroyed or blocked.</dd>
<dd><code>entities</code> - all movable tokens belonging to the opponent.</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>true if at least one token from entities has a possible move to the position pos.</dd>
</dl>
</li>
</ul>
<a name="cloneAndPutOnBoard-java.util.Vector-towerwarspp.board.Entity:A:A-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>cloneAndPutOnBoard</h4>
<pre>private&nbsp;java.util.Vector&lt;<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&gt;&nbsp;cloneAndPutOnBoard(java.util.Vector&lt;<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&gt;&nbsp;list,
                                                    <a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>[][]&nbsp;cloneBoard)</pre>
<div class="block">Clones all entities in the given entity list and saves the clones on the correct positions
 in the specified array representation of the board.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>list</code> - the list of entities which has to be cloned.</dd>
<dd><code>cloneBoard</code> - the 2-dimensional array representation of the board
                   where all the cloned entities have to be saved on the correct positions.</dd>
</dl>
</li>
</ul>
<a name="clone--">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>clone</h4>
<pre>public&nbsp;<a href="../../towerwarspp/board/Board.html" title="class in towerwarspp.board">Board</a>&nbsp;clone()</pre>
<div class="block">Clones the current <a href="../../towerwarspp/board/Board.html" title="class in towerwarspp.board"><code>Board</code></a> object and returns the clone.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Overrides:</span></dt>
<dd><code>clone</code>&nbsp;in class&nbsp;<code>java.lang.Object</code></dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the clone oof this <a href="../../towerwarspp/board/Board.html" title="class in towerwarspp.board"><code>Board</code></a> object.</dd>
</dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/Board.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../index-all.html">Index</a></li>
<li><a href="../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li>Prev&nbsp;Class</li>
<li><a href="../../towerwarspp/board/BViewer.html" title="class in towerwarspp.board"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../index.html?towerwarspp/board/Board.html" target="_top">Frames</a></li>
<li><a href="Board.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</body>
</html>
